//+------------------------------------------------------------------+
//|                                 Leon_BO_Arrow_Indicator_V1.1.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

//V1.2
//Change candle break BB Line instead of Close outside

//V1.3: add statistical data


#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_width1 1
#property indicator_color2 White
#property indicator_width2 1


extern double Arrow_space = 4.5;
extern int    ArrowsUpCode       = 233;
extern int    ArrowsDnCode       = 234;
extern bool   AlertOnCurrent = True;
extern string __Signal_break_BB__="<<= VertexSignal must break VertexBollingerBands ?=>>";
extern bool VBB_break = true;

extern string __Arrow_Filter__="<<= Dont Show Arrows on counter-candles ?=>>";
extern bool candle_filter = true;
extern string __Bollinger_Bands__="<<= Bollinger Bands Settings =>>";
extern bool    Use_BB       =  true;
extern int BB_Period=20;
extern double BB_Deviations=2.2;
 int BB_Shift=0;

extern string __Vertex__="<<= Vertex Settings =>>";


extern int Processed        = 2000;
extern int Control_Period   = 20;

extern int Signal_Period    = 3;
extern int Signal_Method    = MODE_SMA;

extern int BB_Up_Period     = 12;
extern double BB_Up_Deviation  = 2.2;

extern int BB_Dn_Period     = 12;
extern double BB_Dn_Deviation  = 2.2;

extern double levelOb       = 6;
extern double levelOs       = -6;





 bool   alertsOn        = true;
 bool   alertsOnCurrent = true;
 bool   alertsMessage   = true;
 bool   alertsSound     = true;
 bool   alertsEmail     = false;
 string soundfile       = "alert2.wav";

extern string  Stat_             =  "<<== Statistical Data ==>>";
extern int     ExpiryCandles     =  2;
input ENUM_BASE_CORNER  TextCorner  =  CORNER_LEFT_LOWER;
extern string  TextFont          =  "Arial";
extern int     TextSize          =  12;
extern color   TextColor         =  Silver;



bool show_arrow = true;
bool enable_alert = true;

double arr_up[];
double arr_dn[];

double     myPoint;
int        myDigits;

int gAlertShift = 0;


datetime NewBarCheck;

//--- Statistical...

int gITM = 0, gOTM = 0;

//---

string IID;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
  
   myPoint     =  MarketInfo(Symbol(),MODE_POINT);
   myDigits    =  MarketInfo(Symbol(),MODE_DIGITS);
   if(myDigits==3 || myDigits==5)
   {
      myPoint     =  myPoint  *  10;
      myDigits    =  myDigits -1;
   }    
  
   if(show_arrow)
   {
      SetIndexBuffer(0, arr_up);
      SetIndexBuffer(1, arr_dn);  
      SetIndexStyle(0, DRAW_ARROW);
      SetIndexArrow(0, ArrowsUpCode);
      SetIndexStyle(1, DRAW_ARROW);
      SetIndexArrow(1, ArrowsDnCode);
      
      SetIndexLabel(0, "BUY Signal");
      SetIndexLabel(1, "SELL Signal");

      IndicatorDigits(Digits);
   }
   
   gAlertShift = 1;
   if(AlertOnCurrent) gAlertShift = 0;
   
   //---
   
   NewBarCheck = 0;
   IID = "fct_Indy_";
   //----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   ObjectDelete("EntryLine11");
   fnDeleteAllObj();
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{

   int    counted_bars=IndicatorCounted();
   //----   
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   int j;
   for(int i=limit; i>=0; i--)
   {
      arr_up[i] = EMPTY_VALUE; arr_dn[i] = EMPTY_VALUE;      
      
      j=i;
      double var1 = 0;
      double var2 = 0;
      for (j = i; j <= i + 9; j++) var2 += MathAbs(High[j] - Low[j]);
      var1 = var2 / 10.0;
      
  
      double VTSignal =(iCustom(Symbol(), 0, "!vertex",Processed,Control_Period,Signal_Period,Signal_Method,BB_Up_Period,BB_Up_Deviation,BB_Dn_Period,BB_Dn_Deviation,levelOb,levelOs, 0, i) ) ;
            double VTBBup = (iCustom(Symbol(), 0, "!vertex",Processed,Control_Period,Signal_Period,Signal_Method,BB_Up_Period,BB_Up_Deviation,BB_Dn_Period,BB_Dn_Deviation,levelOb,levelOs, 2, i) ) ;
                  double VTBBdn = (iCustom(Symbol(), 0, "!vertex",Processed,Control_Period,Signal_Period,Signal_Method,BB_Up_Period,BB_Up_Deviation,BB_Dn_Period,BB_Dn_Deviation,levelOb,levelOs, 3, i) ) ;


      double bbup1=iBands(Symbol(),0,BB_Period,BB_Deviations,BB_Shift,0,MODE_UPPER,i);
      double bbdn1=iBands(Symbol(),0,BB_Period,BB_Deviations,BB_Shift,0,MODE_LOWER,i);
      double low1=iLow(Symbol(),0,i);
      double high1=iHigh(Symbol(),0,i);
      double close1=iClose(Symbol(),0,i);


      
      if(
      
        VTSignal <=levelOs && (!candle_filter || Open[i]>=Close[i]) && (!VBB_break || VTSignal < VTBBdn)
                        && (!Use_BB || low1<=bbdn1)
                    
           
         
        )
      {
         arr_up[i]=iLow(Symbol(),0,i) - (var1/Arrow_space);
           
      }
      else if(
       
       VTSignal>=levelOb && (!candle_filter || Open[i]<=Close[i]) && (!VBB_break || VTSignal > VTBBup)
        && (!Use_BB || high1>=bbup1)
               
        )
      {
         arr_dn[i]=iHigh(Symbol(),0,i) + (var1/Arrow_space);      
             
      }        
   }
   
   static datetime dtlboai11;
   
   if(dtlboai11!=iTime(Symbol(),0,0))
   {
      string stralert;
      if(arr_up[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Long Signal"+ Symbol()+ " " + strtf(Period()) + "Time: "+TimeToStr(TimeCurrent(),TIME_MINUTES) + "";
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
      else if(arr_dn[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Short Signal"+ Symbol()+ " " + strtf(Period()) + "Time: "+TimeToStr(TimeCurrent(),TIME_MINUTES) + "";
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
   }
   
   //---
   
   //--- Get statistical data
   
   if(!isNewBar()) return(0);
   gITM = 0; gOTM = 0;
   for(j = 1; j < Bars; j++)
   {
      fnGetITM_OTM(j, gITM, gOTM);
   }
   
   fnShowInfor();
   
   //----
   return(0);   
}

//+------------------------------------------------------------------+

string strtf(int tf)
{
   switch(tf)
   {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN1");
      default:return("Unknown timeframe");
   }
}


void DrawLine(string sName, double dPrice,color cLineClr=CLR_NONE)
{
    int iWidth=1;
    string sObjName = sName;

    if(ObjectFind(sObjName) == -1){
        // create object 
        ObjectCreate(sObjName,OBJ_HLINE, 0, 0,0);
    }

    ObjectSet(sObjName,OBJPROP_PRICE1,dPrice);
    ObjectSet(sObjName, OBJPROP_COLOR, cLineClr);
    ObjectSet(sObjName, OBJPROP_WIDTH, iWidth);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void fnGetITM_OTM(int pShift, int &pITM, int &pOTM)
{
   int lExpiryStart = pShift - 1;
   int lExpiryEnd = pShift - ExpiryCandles;
   if(lExpiryEnd <= 0) return;
   //
   if(arr_up[pShift] != EMPTY_VALUE && arr_dn[pShift] != EMPTY_VALUE) return;   
   if(arr_up[pShift] != EMPTY_VALUE)
   {
      if(Open[lExpiryStart] < Close[lExpiryEnd]) pITM++;
      else pOTM++;
   }
   else
   if(arr_dn[pShift] != EMPTY_VALUE)
   {
      if(Open[lExpiryStart] > Close[lExpiryEnd]) pITM++;
      else pOTM++;
   }
}

//+------------------------------------------------------------------+

bool isNewBar()
{   
   bool NewBar = false;
   if (NewBarCheck != iTime(NULL, 0, 0))
   {
      NewBarCheck = iTime(NULL, 0, 0);
      NewBar = true;
   }  
   return (NewBar);
}

//+------------------------------------------------------------------+

void fnShowInfor()
{
   int iX, iY;
   int lXDist = 40;
   //
   if(TextCorner == CORNER_LEFT_LOWER) iY = 60;
   else iY = 30;
   iX = 10; 
   fnDrawLabel(IID + "ITM_", iX, iY, "ITM", TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "OTM_", iX, iY, "OTM", TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "IOTM_", iX, iY, "Percent", TextSize, TextFont, TextColor, TextCorner);
   //
   if(TextCorner == CORNER_LEFT_LOWER) iY -= 30;
   else iY += 30;
   iX = 10;
   fnDrawLabel(IID + "ITMV_", iX, iY, DoubleToStr(gITM, 0), TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "OTMV_", iX, iY, DoubleToStr(gOTM, 0), TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   if(gOTM + gITM > 0)
      fnDrawLabel(IID + "IOTMV_", iX, iY, DoubleToStr(gITM*100/(gOTM + gITM), 2), TextSize, TextFont, TextColor, TextCorner);
   else
      fnDrawLabel(IID + "IOTMV_", iX, iY, "N/A", TextSize, TextFont, TextColor, TextCorner);
   ChartRedraw(ChartID());
}

//+------------------------------------------------------------------+


void fnDrawLabel(string iName, int iX, int iY, string iText, int iFontSize, string iFontName, color iColor, int iCorner = 0)
{
   if(ObjectFind(iName < 0)) ObjectCreate(ChartID(), iName, OBJ_LABEL, ChartWindowFind(), 0, 0);
   ObjectSetInteger(ChartID(), iName, OBJPROP_CORNER, iCorner);
   //ObjectSetInteger(ChartID(), iName, OBJPROP_ANCHOR, ANCHOR_LEFT_UPPER);
   ObjectSet(iName, OBJPROP_BACK, FALSE);
   ObjectSet(iName, OBJPROP_XDISTANCE, iX);
   ObjectSet(iName, OBJPROP_YDISTANCE, iY);
   ObjectSetText(iName, iText, iFontSize, iFontName, iColor);
}

//---

void fnDeleteAllObj()
{
   string lookFor = IID;
   string objectName;
   int lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal()-1; i >= 0; i--)
   {
      objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//+------------------------------------------------------------------+